/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.model;
import android.content.ContentProviderOperation;
import android.content.ContentProviderResult;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.content.OperationApplicationException;
import android.net.Uri;
import android.os.RemoteException;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.CallNote;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.Notes.TextNote;

import java.util.ArrayList;


public class Note {
    private ContentValues mNoteDiffValues;
    private NoteData mNoteData;
    private static final String TAG = "Note";
    /**
     * Create a new note id for adding a new note to databases
     */
    public static synchronized long getNewNoteId(Context context, long folderId) {
        // 创建同步方法，以保证数据库插入操作的唯一性

        // 创建新笔记所需的ContentValues对象
        ContentValues values = new ContentValues();
        long createdTime = System.currentTimeMillis();
        // 插入当前时间作为笔记创建时间和最近修改时间
        values.put(NoteColumns.CREATED_DATE, createdTime);
        values.put(NoteColumns.MODIFIED_DATE, createdTime);
        // 设置笔记类型为普通笔记
        values.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
        // 设置本地是否修改
        values.put(NoteColumns.LOCAL_MODIFIED, 1);
        // 设置笔记所属的文件夹ID
        values.put(NoteColumns.PARENT_ID, folderId);
        // 将ContentValues插入到数据库表Notes.CONTENT_NOTE_URI中，并返回新笔记的Uri对象
        Uri uri = context.getContentResolver().insert(Notes.CONTENT_NOTE_URI, values);

        long noteId = 0;
        try {
            // 从Uri中获取新笔记的ID，并转换成long类型
            noteId = Long.valueOf(uri.getPathSegments().get(1));
        } catch (NumberFormatException e) {
            // 如果出现异常，记录错误信息，并将noteId设置为0
            Log.e(TAG, "Get note id error: " + e.toString());
            noteId = 0;
        }
        if (noteId == -1) {
            // 如果得到的noteId为-1，则抛出异常
            throw new IllegalStateException("Wrong note id: " + noteId);
        }
        // 返回新笔记的ID
        return noteId;
    }

    public Note() {                  //Note类的构造函数
        mNoteDiffValues = new ContentValues();      //创建mNoteDiffValues来存储键值对的对象
        mNoteData = new NoteData();          //用于存储笔记的实际数据，并提供对笔记的读写方法
    }

    public void setNoteValue(String key, String value) {
        mNoteDiffValues.put(key, value); // 将key,value存储在mNoteDiffValues中
        mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1); // 标记本地被修改过
        mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis()); // 标记最近修改时间为当前系统时间
    }

    public void setTextData(String key, String value) {
        mNoteData.setTextData(key, value); // 设置文本数据，即将key和value存储到mNoteData中
    }

    public void setTextDataId(long id) {
        mNoteData.setTextDataId(id); // 为文本数据设置ID，方便在后续的操作中进行对应
    }

    public long getTextDataId() {
        return mNoteData.mTextDataId; // 获取文本数据ID
    }

    public void setCallDataId(long id) {
        mNoteData.setCallDataId(id); // 存储该Note的电话数据ID
    }

    public void setCallData(String key, String value) {
        mNoteData.setCallData(key, value); // 存储电话相关数据，即将key和value存储到mNoteData中
    }

    public boolean isLocalModified() {         //判断当前笔记是否被本地修改过
        return mNoteDiffValues.size() > 0 || mNoteData.isLocalModified();
    }

    /**
     * 同步笔记数据到云端方法
     *
     * @param context 上下文对象
     * @param noteId 笔记ID
     * @return 如果笔记数据同步成功，则返回true；否则返回false
     */
    public boolean syncNote(Context context, long noteId) {
        // 检查笔记ID的合法性
        if (noteId <= 0) {
            throw new IllegalArgumentException("Wrong note id:" + noteId);
        }

        // 如果本地未做修改，则直接返回true
        if (!isLocalModified()) {
            return true;
        }

        /**
         * In theory, once data changed, the note should be updated on {@link NoteColumns#LOCAL_MODIFIED} and
         * {@link NoteColumns#MODIFIED_DATE}. For data safety, though update note fails, we also update the
         * note data info
         */
        // 使用ContentResolver更新本地笔记数据
        if (context.getContentResolver().update(
                ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId), mNoteDiffValues, null,
                null) == 0) {
             // 如果更新操作失败，则记录一条错误日志
            Log.e(TAG, "Update note error, should not happen");
            // 无论更新是否成功，都清除笔记差异数据对象mNoteDiffValues中的数据
            // 这样做是为了确保下次同步操作不会再次上传已经同步的数据
        }
        mNoteDiffValues.clear();

        // 如果笔记数据有本地修改，则将修改后的数据上传到云端
        if (mNoteData.isLocalModified()
                && (mNoteData.pushIntoContentResolver(context, noteId) == null)) {
            // 如果上传失败，则返回false
            return false;
        }

        // 如果笔记数据同步成功，则返回true
        return true;
    }

    /**
     * 笔记数据类，用于存储笔记的文本内容和通话记录数据
     */
    private class NoteData {
        // 文本内容在ContentProvider中的ID
        private long mTextDataId;

        // 文本内容的键值对的集合
        private ContentValues mTextDataValues;

        // 通话记录在ContentProvider中的ID。
        private long mCallDataId;

        // 通话记录的键值对的集合。
        private ContentValues mCallDataValues;

        // 日志标签
        private static final String TAG = "NoteData";

        /**
         * 构造函数，用于初始化成员变量
         */
        public NoteData() {
            mTextDataValues = new ContentValues(); // 存储笔记文本数据的键值对
            mCallDataValues = new ContentValues(); // 存储笔记电话数据的键值对
            mTextDataId = 0; // 记录笔记文本数据在数据库中的ID
            mCallDataId = 0; // 记录笔记电话数据在数据库中的ID
        }

        // 判断笔记是否已被本地修改过
        boolean isLocalModified() {
            return mTextDataValues.size() > 0 || mCallDataValues.size() > 0;
        }

        // 设置笔记文本数据在数据库中的ID
        void setTextDataId(long id) {
            if(id <= 0) {
                throw new IllegalArgumentException("Text data id should larger than 0");
            }
            mTextDataId = id;
        }

        // 设置笔记电话数据在数据库中的ID
        void setCallDataId(long id) {
            if (id <= 0) {
                throw new IllegalArgumentException("Call data id should larger than 0");
            }
            mCallDataId = id;
        }

        // 修改笔记电话数据
        void setCallData(String key, String value) {
            mCallDataValues.put(key, value);
            mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1);
            mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis());
        }

        // 修改笔记文本数据
        void setTextData(String key, String value) {
            mTextDataValues.put(key, value);
            mNoteDiffValues.put(NoteColumns.LOCAL_MODIFIED, 1);
            mNoteDiffValues.put(NoteColumns.MODIFIED_DATE, System.currentTimeMillis());
        }

        Uri pushIntoContentResolver(Context context, long noteId) {
            /**
             * Check for safety
             */
            if (noteId <= 0) {
                throw new IllegalArgumentException("Wrong note id:" + noteId);
            }

            ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
            ContentProviderOperation.Builder builder = null;

            if(mTextDataValues.size() > 0) {
                mTextDataValues.put(DataColumns.NOTE_ID, noteId);
                if (mTextDataId == 0) {
                    mTextDataValues.put(DataColumns.MIME_TYPE, TextNote.CONTENT_ITEM_TYPE);
                    Uri uri = context.getContentResolver().insert(Notes.CONTENT_DATA_URI,
                            mTextDataValues);
                    try {
                        setTextDataId(Long.valueOf(uri.getPathSegments().get(1)));
                    } catch (NumberFormatException e) {
                        Log.e(TAG, "Insert new text data fail with noteId" + noteId);
                        mTextDataValues.clear();
                        return null;
                    }
                } else {
                    builder = ContentProviderOperation.newUpdate(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mTextDataId));
                    builder.withValues(mTextDataValues);
                    operationList.add(builder.build());
                }
                mTextDataValues.clear();
            }

            if(mCallDataValues.size() > 0) {
                mCallDataValues.put(DataColumns.NOTE_ID, noteId);
                if (mCallDataId == 0) {
                    mCallDataValues.put(DataColumns.MIME_TYPE, CallNote.CONTENT_ITEM_TYPE);
                    Uri uri = context.getContentResolver().insert(Notes.CONTENT_DATA_URI,
                            mCallDataValues);
                    try {
                        setCallDataId(Long.valueOf(uri.getPathSegments().get(1)));
                    } catch (NumberFormatException e) {
                        Log.e(TAG, "Insert new call data fail with noteId" + noteId);
                        mCallDataValues.clear();
                        return null;
                    }
                } else {
                    builder = ContentProviderOperation.newUpdate(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mCallDataId));
                    builder.withValues(mCallDataValues);
                    operationList.add(builder.build());
                }
                mCallDataValues.clear();
            }

            if (operationList.size() > 0) {
                try {
                    ContentProviderResult[] results = context.getContentResolver().applyBatch(
                            Notes.AUTHORITY, operationList);
                    return (results == null || results.length == 0 || results[0] == null) ? null
                            : ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId);
                } catch (RemoteException e) {
                    Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
                    return null;
                } catch (OperationApplicationException e) {
                    Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
                    return null;
                }
            }
            return null;
        }
    }
}
